var QuestionUtils = function()
{
   this.in_array = function (what, where)
   {

        var a=false;

        for(var i=0; i<where.length; i++)
        {
            if(what == where[i])
            {
                a=true;
                break;
            }
        }
        return a;
    }
}

var qUtils = new QuestionUtils();

var addQuestion = function( types )
{
    var self = this;
    var types = types;
    var answer_type='show';

    var $possible_values_tr = $("#qst_add_form tr.tr_qst_possible_values");
    var $answer_type = $("#qst_add_form .qst_answer_type");
    var $form_tr = $("#qst_add_form tr:not(.tr_qst_submit)");

    $answer_type.change( function(){ self.displayPossibleValues(); }  );

    this.displayPossibleValues = function()
    {
        if( qUtils.in_array( $answer_type.val(), types ) )
        {
            if( answer_type != 'show' )
            {
                answer_type = 'show';
                $possible_values_tr.show();
                $form_tr.removeClass('ow_even');
                $("#qst_add_form tr:not(.tr_qst_submit):even").addClass('ow_even');
            }
        }
        else
        {
            if( answer_type != 'hide' )
            {
                answer_type = 'hide';
                $possible_values_tr.hide();
                $form_tr.removeClass('ow_even');
                $("#qst_add_form tr:not(.tr_qst_submit,.tr_qst_possible_values):even").addClass('ow_even');
            }
        }
    }
}

var editQuestion = function( $params )
{
    var self = this;
    //var types = $params.types;
    var answer_type='show';

    self.sentRequest = false;
    self.responderUrl = $params.ajaxResponderUrl;
    self.deleteValueConfirmMessage = $params.deleteValueConfirmMessage;

    var $form = $("#qst_edit_form");
    var $possible_values_tr = $("#qst_edit_form tr.tr_qst_possible_values");
    var $answer_type = $("#qst_edit_form .qst_answer_type");
    var $form_tr = $("#qst_edit_form tr:not(.tr_qst_submit)");
    var $sortable = $form.find(".question_values");
    var $questionValueTemplate = $form.find(".question_value_block_template");

    $sortable.find('.question_value_block').bind( "mouseover", function(){ $(this).find('.quest_buttons').show(); } )
                    .bind( "mouseout", function(){ $(this).find('.quest_buttons').hide(); } );

    $sortable.find('.quest_buttons').hide();

    $sortable.sortable({
        items: '.question_value_block'
    });

    $form.submit(
        function()
        {
            var r = {};
            $sortable.find('.question_value_block').each(function(order, o){
                r[$(o).attr('question_value')] = order;
            });

            $("#question_values_order").val( JSON.stringify(r) );
        } );

    $answer_type.change( function(){ self.displayPossibleValues(); }  );

    $sortable.find('.question_value_delete').click( function(){ self.deleteValue( this ) });

    this.deleteValue = function( $element )
    {
        if( self.sentRequest == false )
        {
            if( confirm( self.deleteValueConfirmMessage ) )
            {
                self.sentRequest = true;

                $.ajax( {
                    url: self.responderUrl,
                    type: 'POST',
                    data: { command: 'DeleteQuestionValue', questionId: $('#edit_questionId').val(), value: $($element).parents('.question_value_block').attr('question_value') },
                    dataType: 'json',
                    success: function( data )
                    {
                        self.sentRequest = false;

                        if( data.result == true )
                        {
                             $($element).parents('.question_value_block').remove();
                        }
                    }
                } );
            }
        }
    }

    this.displayAddValues = function( $values )
    {
        var itemsCount = 0;
        $.each($values, function( key, item )
        {
            itemsCount++;
            var $value = $questionValueTemplate.clone()
            $value.removeClass('question_value_block_template');
            $value.addClass('question_value_block');
            $value.attr('question_value', key);
            $value.find('div.quest_value').text( item );

            $value.find('.question_value_delete').click( function(){ self.deleteValue( this ) } )
            $value.bind( "mouseover", function(){ $(this).find('.quest_buttons').show(); } )
                .bind( "mouseout", function(){ $(this).find('.quest_buttons').hide(); } );
            $value.find('.quest_buttons').hide();
            $value.show();
            $sortable.append($value);
        });

        if( itemsCount > 0 )
        {
            $sortable = $form.find(".question_values");
            $sortable.sortable( 'refresh' );
        }
    }
}

var indexQuestions = function( $params )
{
    var self = this;
    var questionEditUrl = $params.questionEditUrl;

    $('.question_values').click( function()  { $(this).parents('center:get(0)').next('div').toggle(); } );
    $('.question_edit_button').click( function() {
        var id = $(this).prev('input').val();
        window.location = questionEditUrl + 'questionId/' + id;
    } );
}


